<?php

//class Mbe_Shipping_Block_Adminhtml_Sales_Shipment_Grid extends Mage_Adminhtml_Block_Sales_Shipment_Grid
class Mbe_Shipping_Block_Adminhtml_Sales_Shipment_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
    public function __construct()
    {
        parent::__construct();
        $this->setId('mbe_shipping_grid');
        $this->setDefaultSort('increment_id');
        $this->setDefaultDir('DESC');
        $this->setSaveParametersInSession(true);
        $this->setUseAjax(true);
    }

    protected function _getCollectionClass()
    {
        return 'sales/order_shipment_grid_collection';
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getResourceModel($this->_getCollectionClass());
        $collection->join(array('orders' => 'sales/order'), 'main_table.order_id = orders.entity_id  AND orders.shipping_method like \''.Mbe_Shipping_Helper_Data::MBE_SHIPPING_PREFIX.'%\'', array(
            'shipping_method' => 'shipping_method',
            //'country_id' => 'country_id'
        ));

//        $select = $collection->getSelect();
//        var_dump($select->__toString());


        /*
        $select = $collection->getSelect();
        var_dump($select->__toString());
        $id = 1;
        $select->where("main_table.entity_id = ?", $id);

        */

        //die();
        /*
        die();
        $select->where("address_table.country_id = ?", $country);
        $select->where("address_table.country_id = ?", $country);
        */
        $this->setCollection($collection);
        return parent::_prepareCollection();
    }

    protected function _filterTypeConditionCallback($collection, $column)
    {
        if (!$value = $column->getFilter()->getValue()) {
            return $this;
        }
        if (!empty($value)) {
            $this->getCollection()->getSelect()->where(
                "orders.shipping_method = '" . $value . "'");
        }

        //Useful to print query during development
        //$select = $collection->getSelect();
        //var_dump($select->__toString());


        return $this;
    }

    protected function _prepareColumns()
    {

        /** @var  $ws Mbe_Shipping_Model_Ws */
        $ws = Mage::getModel('mbe_shipping/ws');

        /** @var $helper Mbe_Shipping_Helper_Data */
        $helper = Mage::helper('mbe_shipping');


        if ($ws->mustCloseShipments()) {


            $this->addColumn('status',
                array(
                    'header'    => $helper->__('Status'),
                    'width'     => '50px',
                    'filter'    => false,
                    'sortable'  => false,
                    'is_system' => true,
                    'renderer'  => 'mbe_shipping/adminhtml_template_grid_renderer_statusrenderer',
                ));
        }

        $this->addColumn('shipping_method',
            array(
                'header'    => $helper->__('Type'),
                'width'     => '50px',
                // 'filter'    => false,
                'sortable'  => false,
                'is_system' => true,

                'type'                      => 'options',
                'options'                   => $helper->getShippingTypesFromShipments(),
                'renderer'                  => 'mbe_shipping/adminhtml_template_grid_renderer_typerenderer',
                'filter_condition_callback' => array($this, '_filterHasUrlConditionCallback')
            ));


        $this->addColumn('increment_id', array(
            'header' => $helper->__('Shipment #'),
            'index'  => 'increment_id',
            'filter_index' => 'main_table.increment_id',
            'type'   => 'text',

        ));


        $this->addColumn('created_at', array(
            'header' => $helper->__('Date Shipped'),
            'index'  => 'created_at',
            'type'   => 'datetime',
        ));

        $this->addColumn('order_increment_id', array(
            'header' => $helper->__('Order #'),
            'index'  => 'order_increment_id',
            'type'   => 'text',
        ));

        $this->addColumn('order_created_at', array(
            'header' => $helper->__('Order Date'),
            'index'  => 'order_created_at',
            'type'   => 'datetime',
        ));

        $this->addColumn('shipping_name', array(
            'header' => $helper->__('Ship to Name'),
            'index'  => 'shipping_name',
        ));

        $this->addColumn('total_qty', array(
            'header' => $helper->__('Total Qty'),
            'index'  => 'total_qty',
            'type'   => 'number',
        ));


        //$link= Mage::helper('adminhtml')->getUrl('adminhtml/catalog_product/edit/') .'id/$entity_id';

        //http://magento.stackexchange.com/questions/4449/link-for-action-column-in-custom-grid


        $this->addColumn('action_download',
            array(
                'header'    => $helper->__('WayBill'),
                'width'     => '50px',
                'type'      => 'action',
                'getter'    => 'getId',
                'actions'   => array(
                    array(
                        'caption' => $helper->__('Download Parcel'),
                        'url'     => array('base' => '*/shipment/downloadWaybill'),
                        'field'   => 'shipment_id',
                        'target'  => '_blank'
                    )
                ),
                'renderer'  => 'mbe_shipping/adminhtml_template_grid_renderer_downloadrenderer',
                'filter'    => false,
                'sortable'  => false,
                'is_system' => true
            ));


        $this->addColumn('action',
            array(
                'header'    => $helper->__('Action'),
                'width'     => '50px',
                'type'      => 'action',
                'getter'    => 'getId',
                'actions'   => array(
                    array(
                        'caption' => $helper->__('View'),
                        'url'     => array('base' => '*/sales_shipment/view'),
                        'field'   => 'shipment_id'
                    ),
                ),
                'filter'    => false,
                'sortable'  => false,
                'is_system' => true
            ));


        $this->addExportType('*/*/exportCsv', $helper->__('CSV'));
        $this->addExportType('*/*/exportExcel', $helper->__('Excel XML'));

        return parent::_prepareColumns();
    }

    public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current' => true));
    }

    /**
     * Prepare and set options for massaction
     *
     * @return Mage_Adminhtml_Block_Sales_Shipment_Grid
     */
    protected function _prepareMassaction()
    {

        /** @var  $ws Mbe_Shipping_Model_Ws */
        $ws = Mage::getModel('mbe_shipping/ws');

        /** @var $helper Mbe_Shipping_Helper_Data */
        $helper = Mage::helper('mbe_shipping');

        if ($ws->mustCloseShipments()) {


            $this->setMassactionIdField('entity_id');
            $this->getMassactionBlock()->setFormFieldName('shipment_ids');
            $this->getMassactionBlock()->setUseSelectAll(false);

            $this->getMassactionBlock()->addItem('close_shippings', array(
                'label' => $helper->__('Close Shippings'),
                'url'   => $this->getUrl('*/shipment/closeshipments'),
            ));
        }

        return $this;
    }

}