<?php

class Mbe_Shipping_Block_Adminhtml_Shipping_Shipment extends Mage_Core_Block_Template
{
    /** @var  $helper Mbe_Shipping_Helper_Data */
    protected $helper;
    /** @var  $ws Mbe_Shipping_Model_Ws */
    protected $ws;

    public function _construct()
    {

        $this->helper = Mage::helper("mbe_shipping");

        $this->ws = Mage::getModel('mbe_shipping/ws');
    }

//    public function getShippingStatus()
//    {
//        return $this->getTrackingArray();
//    }

    public function getTrackingArray()
    {
        $result = array();
        $tracks = $this->getShipment()->getAllTracks();
        foreach ($tracks as $track) {

            if ($track->getCarrierCode() == "mbe_shipping") {
                $trackingNumber = $track->getTrackNumber();
                $current = array(
                    'tracking_number' => $trackingNumber,
                    'status'          => $this->helper->getTrackingStatus($trackingNumber),
                );

                array_push($result, $current);
            }
        }
        return $result;
    }


    /**
     * Retrieve shipment model instance
     *
     * @return Mage_Sales_Model_Order_Shipment
     */
    public function getShipment()
    {
        return Mage::registry('current_shipment');
    }

    public function getShipmentIncrementId()
    {
        return $this->getShipment()->getIncrementId();
    }

    public function getShipmentId()
    {
        return $this->getShipment()->getId();
    }


    public function getOrder()
    {
        return $this->getShipment()->getOrder();
    }

    public function mustCloseShipments()
    {
        return $this->ws->mustCloseShipments();
    }

}